/* 
// Project : SD-CARD
// Date    : 25.08.2010
// Author  : XMEGA
// Company : PRIVAT
// Chip type               : ATxmega128A3
// AVR Core Clock frequency: 16,000000 MHz
// Display EADOGM102 
*/
		      	
/*					Atxmega128a3						DOGM102
// ----------------------------------------------------------------------
// LCD_A0      2     // PC2 (Pin 18) -> Display A0		PIN 26
// LCD_RST     3     // PC3 (Pin 19) -> Display RST		PIN 27 
// LCD_CS      4     // PC4 (Pin 20) -> Display CS0	   	PIN 28 
// SPI_MOSI    5     // PC5 (Pin 21) -> Display MOSI	PIN 24
// SPI_MISO   
// SPI_SCK     7     // PC7 (Pin 23) -> Display SCK		PIN 25



//	ATXMEGA SPID
  	
//	MMC_Chip_Select 	(Pin30)	   	MMC/SD-Karte (CS)
//	MMC_MOSI    		(Pin31)	  	MMC/SD-Karte (DI)
//	MMC_MISO    		(Pin32)	  	MMC/SD-Karte (DO)
//	MMC_Clock 			(Pin33)	   	MMC/SD-Karte (CLK)

*/

#include "tools.h"


static FILE mystdout = FDEV_SETUP_STREAM(dogm128_putchar, NULL, _FDEV_SETUP_WRITE); // bindet printf() ein

volatile unsigned char 	TimingDelay;	// fuer mmc.c


int main(void)
{

	
	system_clocks_init(); 	//  Internal 32/2 = 16MHz  RC oscillator intern


	TCD0.PER = 125; //  Sekundenabfrage fr Schreiben SDCARD
	TCD0.CTRLA = ( TCD0.CTRLA & ~TC0_CLKSEL_gm ) | TC_CLKSEL_DIV1024_gc;
	TCD0.INTCTRLA = ( TCD0.INTCTRLA & ~TC0_OVFINTLVL_gm ) | RTC_OVFINTLVL_MED_gc;
	TimingDelay = 0;		// initialisierung der zaehl variable	

	
	// Enable HI/MED/LO interrupt level
	// Interupt einschalten
	PMIC.CTRL |= PMIC_HILVLEN_bm; 
	PMIC.CTRL |= PMIC_MEDLVLEN_bm;
	PMIC.CTRL |= PMIC_LOLVLEN_bm;
	
	
	sei(); 


	SPI_PORT_Init(); 	// SPI DOGM Port Init
 	SPI_Init();			// SPI DOGM Init
	lcd_init();			// DOGM Init
	delay_ms(100);  	// 100ms warten Display Init
	
	stdout = &mystdout; // bindet printf() ein 

	
	lcd_set_font(FONT_PROP_8, NORMAL); 		// fr xprintf vorbereiten

	lcd_moveto_xy(1,20); printf("SD-Card 0.6.3"); // Anzeige Start

 
	unsigned char file_name [] = "test.txt"; 	
	unsigned char str [] = "Hallo Datei!";
	unsigned long int seek;

	// timer0 config  **************************************************
	// initialisierung, auf jeden fall vor mmc_init(), 
	// denn da wird der timer benoetigt!


	
	// sd/mmc config  **************************************************
	
	if( FALSE == mmc_init() ){
	} 

	//uputs((unsigned char*)"...");
	lcd_moveto_xy(3,20); printf("Init");		
	
	// fat config ******************************************************
	if( FALSE == fat_loadFatData() ){
		//return;
	}

	// wenn auf dem terminal "Boot...OK" zu lesen ist, war initialisierung erfolgreich!
	lcd_moveto_xy(5,20); printf("OK!!");		

	#if (MMC_WRITE ==TRUE)		// create and append only if write is TRUE
		
			//lcd_moveto_xy(7,20); printf("OK");		

		// ****************************************************
		// if file exists, it will be opened and then append to it.
		if( MMC_FILE_OPENED == ffopen(file_name,'r') ){			
			lcd_moveto_xy(6,20); printf("lesen1");
			ffseek(file.length);
		   	ffwrites(str);				
			ffwrite(0x0D);		// new line in file
		   	ffwrite(0x0A);
			ffclose();
		}
		
		// ***************************************************
		// if the file does not exist, it will be created and written to it.
		if(MMC_FILE_CREATED == ffopen(file_name,'c') ){
			lcd_moveto_xy(7,20); printf("write1");	

			ffwrites(str);				
			ffwrite(0x0D);		// new line in file
		   	ffwrite(0x0A);
			ffclose();
		} 	
	#endif 

	// ***************************************************
	// read file complete and print via uart!
	if( MMC_FILE_OPENED == ffopen(file_name,'r') ){			
		seek = file.length;
		do{
		}while(--seek);
		ffclose();
	}
	
	
	while(1)
	{	

	
	}

	

		return (0);// retrun from main.c
}





// System Clocks initialization
void system_clocks_init(void)
{
unsigned char n,s;

// Save interrupts enabled/disabled state
s=SREG;
// Disable interrupts
cli();

// Internal 32/2 = 16MHz  RC oscillator intern
// Enable the internal 32 MHz RC oscillator
OSC.CTRL|=OSC_RC32MEN_bm;

// System Clock prescaler A division factor: 2
// System Clock prescalers B & C division factors: B:1, C:1
// ClkPer4: 16000,000 kHz
// ClkPer2: 16000,000 kHz
// ClkPer:  16000,000 kHz
// ClkCPU:  16000,000 kHz
n=(CLK.PSCTRL & (~(CLK_PSADIV_gm | CLK_PSBCDIV1_bm | CLK_PSBCDIV0_bm))) |
	CLK_PSADIV_2_gc | CLK_PSBCDIV_1_1_gc;
CCP=CCP_IOREG_gc;
CLK.PSCTRL=n;

// Disable the autocalibration of the internal 32 MHz RC oscillator
DFLLRC32M.CTRL&= ~DFLL_ENABLE_bm;

// Wait for the internal 32 MHz RC oscillator to stabilize
while ((OSC.STATUS & OSC_RC32MRDY_bm)==0);

// Select the system clock source: 32 MHz Internal RC Osc.
n=(CLK.CTRL & (~CLK_SCLKSEL_gm)) | CLK_SCLKSEL_RC32M_gc;
CCP=CCP_IOREG_gc;
CLK.CTRL=n;

// Disable the unused oscillators: 2 MHz, internal 32 kHz, external clock/crystal oscillator, PLL
OSC.CTRL&= ~(OSC_RC2MEN_bm | OSC_RC32KEN_bm | OSC_XOSCEN_bm | OSC_PLLEN_bm);

// Peripheral Clock output: Disabled
PORTCFG.CLKEVOUT=(PORTCFG.CLKEVOUT & (~PORTCFG_CLKOUT_gm)) | PORTCFG_CLKOUT_OFF_gc;

// Restore interrupts enabled/disabled state
SREG=s;


}




int dogm128_putchar(char c, FILE *stream) // // bindet printf() ein
{
 	lcd_putc(c);
    return 0;
}






ISR(TCD0_OVF_vect ISR_BLOCK)	// 100ms fr Delay SD-Card
{


TimingDelay = (TimingDelay==0) ? 0 : TimingDelay-1;


}




